﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestBasicQuery
{
   public partial class Form1 : Form
   {
      // Define the context used to access the database.
      UserFavoritesModelContainer UserFavoritesContext;

      public Form1()
      {
         InitializeComponent();

         // Initialize the database context.
         UserFavoritesContext = new UserFavoritesModelContainer();

         // Query the database for the records you want.
         var dbQuery =
            UserFavoritesContext.UserFavorites.Where(id => id.UserId >= 0).ToArray();
      }

      private void userFavoritesBindingNavigatorSaveItem_Click(object sender, EventArgs e)
      {
         UserFavoritesContext.SaveChanges();
      }

      private void Form1_Load(object sender, EventArgs e)
      {

         // Assign a local copy of the queried records to the
         // binding source.
         userFavoritesBindingSource.DataSource = 
            UserFavoritesContext.UserFavorites.Local;

         // Fill the Favorite Colors list with acceptable colors and
         // choose a default.
         favoriteColorComboBox.DataSource = Enum.GetValues(typeof(ColorNames));
         favoriteColorComboBox.SelectedItem = ColorNames.Red;
      }

      private void toolStripButton1_Click(object sender, EventArgs e)
      {
         // Define and perform the query.
         List<String> Results = UserFavoritesContext.UserFavorites.Where<UserFavorites>(
            query => query.FavoriteColor == ColorNames.Red).
            Select<UserFavorites, String>(item => item.Name).ToList<String>();

         // Create and display the output.
         StringBuilder Output = new StringBuilder();
         foreach (String Result in Results)
            Output.Append(Result + "\r\n");
         MessageBox.Show(Output.ToString());
      }

      private void toolStripButton2_Click(object sender, EventArgs e)
      {
         // Summarize the data.
         var Results = UserFavoritesContext.UserFavorites.Count(
            query => query.FavoriteColor == ColorNames.Red);

         // Display the result.
         MessageBox.Show(String.Format(
            "The number of users who like Red is {0}.", Results));
      }
   }
}
